(function() {
  var http, url;
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
  http = require('http');
  url = require('url');
  exports.setupESI = function() {
    var handleESI;
    return handleESI = function(req, res, next) {
      var end, endWait, write;
      endWait = false;
      write = res.write;
      res.write = function(chunk, encoding) {
        res.write = write;
        if (req.url.indexOf(".html") !== -1) {
          console.log("res.write request.url: " + req.url);
          endWait = true;
          return exports.processESI(chunk, function(err, chunk) {
            res.writeHead(200, {
              'Content-Length': chunk.length,
              'Content-Type': 'text/html'
            });
            endWait = false;
            return res.write(chunk, encoding);
          });
        } else {
          return res.write(chunk, encoding);
        }
      };
      end = res.end;
      res.end = function(data, encoding) {
        res.end = end;
        if (data) {
          res.write(data, encoding);
        }
        if (endWait !== true) {
          return res.end();
        }
      };
      return next();
    };
  };
  exports.processESI = function(data, callback) {
    var displayData, fetchESI, html, searchESI, subESI;
    html = '';
    searchESI = function(data) {
      var esi_tags, k, v, _results;
      html = data.toString();
      console.log("Searching for ESI(s)...");
      esi_tags = html.match(/<esi(.*?) src="(.*?)"(.*?)\/?>/gi);
      if (esi_tags !== null) {
        console.log("Found " + esi_tags.length + " ESI(s)");
        _results = [];
        for (k in esi_tags) {
          v = esi_tags[k];
          _results.push(fetchESI(esi_tags[k].match(RegExp(" src=\"(.*?)\""))[1]));
        }
        return _results;
      } else {
        console.log("Found 0 ESI(s)");
        return displayData();
      }
    };
    fetchESI = function(src) {
      var options, uri, _ref, _ref2, _ref3, _ref4, _ref5;
      console.log("Fetching ESI '" + src + "'");
      uri = url.parse(src);
      options = {
        host: (_ref = uri.hostname) != null ? _ref : 'localhost',
        port: (_ref2 = uri.port) != null ? _ref2 : (uri.protocol != null ? 80 : 5678),
        path: ((_ref3 = uri.pathname) != null ? _ref3 : '/') + ((_ref4 = uri.search) != null ? _ref4 : '') + ((_ref5 = uri.hash) != null ? _ref5 : '')
      };
      return http.get(options, function(res) {
        var body;
        console.log("ESI '" + src + "' returned status " + res.statusCode);
        body = '';
        res.on('data', __bind(function(chunk) {
          return body += chunk.toString();
        }, this));
        return res.on('end', __bind(function() {
          return subESI(src, body);
        }, this));
      });
    };
    subESI = function(src, body) {
      var re, remaining;
      console.log("ESI tag subsitution for '" + src + "'");
      re = new RegExp('<esi(.*?) src="' + RegExp.escape(src) + '"(.*?)\/(>|esi:include>)', 'gi');
      html = html.replace(re, body);
      remaining = html.match(/<esi(.*?) src="(.*?)"(.*?)\/?>/gi);
      if (remaining === null) {
        return displayData();
      } else {
        return console.log(remaining.length + " remaining ESIs");
      }
    };
    displayData = function() {
      console.log("Display Data\n");
      return callback(false, html);
    };
    RegExp.escape = function(text) {
      return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    };
    return searchESI(data);
  };
}).call(this);
