http = require 'http'
url = require 'url'

exports.setupESI = ->
	handleESI = (req, res, next) ->
		endWait = false		

		# MODIFY res.write
		write = res.write  # store the original function   
		# wrap write to hook into the exit path through the layers
		res.write = (chunk, encoding) ->
			res.write = write # put the original back
			unless req.url.indexOf(".html") == -1 # only process ESIs from urls that have '.html'
				console.log "res.write request.url: " + req.url #+ " = " + chunk
				endWait = true
				exports.processESI chunk, (err, chunk) ->
					#console.log 'processESI callback' #+ chunk
					res.writeHead 200, 
					  'Content-Length': chunk.length
					  'Content-Type': 'text/html'
					endWait = false
					res.write chunk, encoding # call the original on callback
				#	res.end()
			else			
				res.write chunk, encoding # call the original				

		# MODIFY res.end
		end = res.end
		res.end = (data, encoding) ->
			res.end = end
			#console.log "res.end request.url: " + req.url + " wait:" + endWait #+ " = " + data
			if data
				res.write data, encoding
			unless endWait == true # only end if not waiting (for async)
				res.end()

		next() # pass through to the next layer

exports.processESI = (data, callback) ->
	html = ''

	searchESI = (data) ->
		html = data.toString()
		console.log "Searching for ESI(s)..."
		esi_tags = html.match(/<esi(.*?) src="(.*?)"(.*?)\/?>/gi)
		if (esi_tags != null)
			console.log "Found " + esi_tags.length+ " ESI(s)"
			for k,v of esi_tags
				fetchESI esi_tags[k].match(RegExp(" src=\"(.*?)\""))[1] # fetch esi using src
		else
			console.log "Found 0 ESI(s)"
			displayData()

	fetchESI = (src) ->
		console.log "Fetching ESI '" + src + "'"
		uri = url.parse(src)
		options =
			host: uri.hostname ? 'localhost'
			port: uri.port ? (if uri.protocol? then 80 else 5678)
			path: (uri.pathname ? '/') + (uri.search ? '') + (uri.hash ? '')
		http.get options, (res) ->
			console.log "ESI '" + src + "' returned status " + res.statusCode
			body = ''
			res.on 'data', (chunk) =>
				body += chunk.toString()
			res.on 'end', =>
				subESI(src, body)

	subESI = (src, body)->
		console.log "ESI tag subsitution for '" + src + "'"
		re = new RegExp('<esi(.*?) src="' + RegExp.escape(src) + '"(.*?)\/(>|esi:include>)', 'gi')
		html = html.replace(re, body)		
		remaining = html.match(/<esi(.*?) src="(.*?)"(.*?)\/?>/gi)
		if (remaining == null) # there are no remaining ESIs to parse, display data
			displayData()
		else
			console.log remaining.length + " remaining ESIs"

	displayData = ->
		console.log "Display Data\n"
		callback false, html

	RegExp.escape = (text) ->
	  text.replace /[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"

	searchESI data